module ResortMirrorReskin1
using ..Ahorn, Maple

@mapdef Entity "ResortMirrorReskin/1" ReskinnableResortMirror(
    x::Integer, y::Integer, path::String="objects/mirror/glassbg"
)

const placements = Ahorn.PlacementDict(
   "Reskinnable Resort Mirror" => Ahorn.EntityPlacement(
      ReskinnableResortMirror
   )
)
function Ahorn.selection(entity::ReskinnableResortMirror)
    x, y = Ahorn.position(entity)
    frameSprite = Ahorn.getSprite("objects/mirror/resortframe", "Gameplay")

    return Ahorn.Rectangle(x - frameSprite.width / 2, y - frameSprite.height, frameSprite.width, frameSprite.height)
end

function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::ReskinnableResortMirror, room::Maple.Room)
    frameSprite = Ahorn.getSprite("objects/mirror/resortframe", "Gameplay")
    glassSprite = Ahorn.getSprite("ahorn/WizardOfWit/baddyglass", "Gameplay")

    glassWidth = frameSprite.width - 4
    glassHeight = frameSprite.height - 8

    Ahorn.drawImage(ctx, glassSprite, -glassHeight / 2, -glassHeight, (glassSprite.width - glassWidth) / 2, glassSprite.height - glassHeight, glassWidth, glassHeight)
    Ahorn.drawImage(ctx, frameSprite, -frameSprite.width / 2, -frameSprite.height)
end

end
