local badeline
local BadelineDummy = require("#celeste.BadelineDummy")

-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/badelinemessesup") then
		setFlag("PoM/badelinemessesup")
		disableMovement()
		say("wizardofwit_allthismadness")
		spawnBadelineDummy(197,220, false)
		say("wizardofwit_itstartedwithyou")
		coroutine.yield(badeline:FloatTo(vector2(engine.Scene.Bounds.Right - 6, badeline.Position.Y - 50)))
		wait(1)
		coroutine.yield(badeline:FloatTo(vector2(engine.Scene.Bounds.Right - 10, badeline.Position.Y)))
		wait(0.5)
		badeline:Vanish()
		enableMovement()
		endCutscene()
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		setFlag("PoM/badelinemessesup")
		enableMovement()
		endCutscene()
    end
end

function spawnBadelineDummy(x,y, relativeToPlayer)
	if relativeToPlayer then
		x = player.Position.X + x
		y = player.Position.Y + y
	end
	badeline = celeste.BadelineDummy(vector2(x, y))
	engine.Scene:Add(badeline)
	badeline.Floatness = 2
	badeline:Appear(engine.Scene, false)
	return badeline
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd