-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/badelineteleport") then
		setFlag("PoM/badelineteleport")
		spawnBadelineDummy(5130,25, false)
		walkTo(5203)
		say("wizardofwit_badelineteleport1")
		walkTo(5198)
		miniTextbox("wizardofwit_badelineteleport2")
		coroutine.yield(badeline:FloatTo(vector2(player.Position.X, player.Position.Y)))
		teleportTo(5875, 600, "c-04", getEnum("Celeste.Player.IntroTypes", "Fall"))
		enableMovement()
		endCutscene()
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		setFlag("PoM/badelineteleport")
		enableMovement()
		teleportTo(5875, 600, "c-03")
		enableMovement()
		endCutscene()
    end
end

function spawnBadelineDummy(x,y, relativeToPlayer)
	if relativeToPlayer then
		x = player.Position.X + x
		y = player.Position.Y + y
	end
	badeline = celeste.BadelineDummy(vector2(x, y))
	engine.Scene:Add(badeline)
	badeline.Floatness = 10
	badeline:Appear(engine.Scene, false)
	return badeline
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd