-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/exitabove") then
		setFlag("PoM/exitabove")
		setFlag("PoM/mirror_disabled")
		walkTo(5236)
		wait(0.5)
		playSprite("lookUp")
		wait(0.5)
		say("wizardofwit_exitabove")
		enableMovement()
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		enableMovement()
    end
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd