-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/mirror_disabled") then
		setFlag("PoM/mirror_disabled")
		endCutscene()
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		setFlag("PoM/mirrordisabled")
		endCutscene()
    end
end

function spawnBadelineDummy(x,y, relativeToPlayer)
	if relativeToPlayer then
		x = player.Position.X + x
		y = player.Position.Y + y
	end
	badeline = celeste.BadelineDummy(vector2(x, y))
	engine.Scene:Add(badeline)
	badeline.Floatness = 10
	badeline:Appear(engine.Scene, false)
	return badeline
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd