-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/reunion") then
		setFlag("PoM/reunion")
		walkTo(6971)
		spawnBadelineDummy(6982,-1550, false)
		playSprite("lookUp")
		coroutine.yield(badeline:FloatTo(vector2(7035,-1538)))
		badeline:Vanish()
		miniTextbox("wizardofwit_reunionyell1")
		spawnBadelineDummy(6944,-1573)
		coroutine.yield(badeline:FloatTo(vector2(6933,-1539)))
		badeline:Vanish()
		spawnBadelineDummy(6985,-1493)
		coroutine.yield(badeline:FloatTo(vector2(7026,-1574)))
		badeline:Vanish()
		spawnBadelineDummy(7029,-1540)
		coroutine.yield(badeline:FloatTo(vector2(6945,-1574)))
		badeline:Vanish()
		spawnBadelineDummy(6953,-1572)
		coroutine.yield(badeline:FloatTo(vector2(6985,-1588)))
		badeline:Vanish()
		spawnBadelineDummy(6944,-1573)
		coroutine.yield(badeline:FloatTo(vector2(6933,-1539)))
		badeline:Vanish()
		spawnBadelineDummy(6985,-1493)
		coroutine.yield(badeline:FloatTo(vector2(7026,-1574)))
		badeline:Vanish()
		spawnBadelineDummy(7029,-1540)
		coroutine.yield(badeline:FloatTo(vector2(6945,-1574)))
		badeline:Vanish()
		miniTextbox("wizardofwit_reunionyell2")
		spawnBadelineDummy(6953,-1572)
		coroutine.yield(badeline:FloatTo(vector2(6985,-1588)))
		badeline:Vanish()
		spawnBadelineDummy(7033,-1540)
		coroutine.yield(badeline:FloatTo(vector2(6985,-1536)))
		wait(1)
		coroutine.yield(badeline:FloatTo(vector2(6994,-1467)))
		coroutine.yield(badeline:FloatTo(vector2(6992,-1467)))
		coroutine.yield(getLevel():ZoomTo(vector2(196, 110), 1.5, 0.5))
		wait(1)
		playSprite("sitDown")
		wait(1)
		say("wizardofwit_reuniontalk1")
	    coroutine.yield(getLevel():ZoomBack(0.5))
		badeline:Vanish()
		enableMovement()
		endCutscene()
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		setFlag("PoM/reunion")
		enableMovement()
		badeline:Vanish()
		enableMovement()
		endCutscene()
    end
end

function spawnBadelineDummy(x,y, relativeToPlayer)
	if relativeToPlayer then
		x = player.Position.X + x
		y = player.Position.Y + y
	end
	badeline = celeste.BadelineDummy(vector2(x, y))
	engine.Scene:Add(badeline)
	badeline.Floatness = 2
	badeline:Appear(engine.Scene, false)
	return badeline
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd