local badeline
local BadelineDummy = require("#celeste.BadelineDummy")

-- Coroutine that does all the cutscene magic.
-- This invloves stuff like walking, jumping, displaying text boxes, etc.
local function onBegin()
	if not getFlag("PoM/descent") then
		setFlag("PoM/descent")
		disableMovement()
		spawnBadelineDummy(20,-10, true)
		say("wizardofwit_descent")
		coroutine.yield(badeline:FloatTo(vector2(5739, -3612)))
		player.ForceCameraUpdate = true
		runTo(5546)
		enableMovement()
		wait(0.1)
		disableMovement()
		runTo(5683)
		enableMovement()
		wait(0.5)
		disableMovement()
		coroutine.yield(badeline:FloatTo(vector2(5732, -3590)))
		say("wizardofwit_onejump")
		walkTo(5721)
		wait(1)
		say("wizardofwit_fallingtime")
		wait(0.5)
		completeArea(true,true,true)
	end
end

-- Function, no yielding actions allowed.
-- That means no walking, waiting etc.
-- Only "clean up" actions.
local function onEnd(level, wasSkipped)
    if wasSkipped then
		setFlag("PoM/descent")
		completeArea(true,false,true)
    end
end

function spawnBadelineDummy(x,y, relativeToPlayer)
	if relativeToPlayer then
		x = player.Position.X + x
		y = player.Position.Y + y
	end
	badeline = celeste.BadelineDummy(vector2(x, y))
	engine.Scene:Add(badeline)
	badeline.Floatness = 2
	badeline:Appear(engine.Scene, false)
	return badeline
end

function playSprite(sprite, duration)
	player.DummyAutoAnimate = false
	player.Sprite:Play(sprite, false, false)
	if (duration) then
		wait(duration)
		player.DummyAutoAnimate = true
	end
end

return onBegin, onEnd

